<?php
// $Id: swftools_simpleviewer.admin.inc,v 1.1.2.4 2010/03/29 22:07:15 stuartgreenfield Exp $

function swftools_simpleviewer_admin_form() {

  // See if colorpicker 2 is loaded
  $colorfield = function_exists('colorpicker_2_or_later') ? 'colorpicker_textfield' : 'textfield';
  
  // Retrieve current defaults
  $saved_settings = _swftools_simpleviewer_settings();
  
  // Initialise array to hold form
  $form = array();

  // Initialise tree from this point forward as want to store an array
  $form['#tree'] = TRUE;
  
  $form['swftools_simpleviewer']['display'] = array(
    '#type' => 'fieldset',
    '#title' => t('Display settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  
  $form['swftools_simpleviewer']['display']['title'] = array(
    '#type' => 'checkbox',
    '#default_value' => $saved_settings['display']['title'],
    '#title' => t('Display title'),
    '#description' => t('Whether to display the node title in the flash animation.'),
  );
  
  $form['swftools_simpleviewer']['display']['album'] = array(
    '#type' => 'checkbox',
    '#default_value' => $saved_settings['display']['album'],
    '#title' => t('Display album name'),
    '#description' => t('Whether to display the album name in the flash animation.'),
  );
  
  $form['swftools_simpleviewer']['display']['link'] = array(
    '#type' => 'checkbox',
    '#default_value' => $saved_settings['display']['link'],
    '#title' => t('Display download link'),
    '#description' => t('Apart from the node title, also display a clickable link to allow downloading the originally uploaded image.'),
  );
  
  $form['swftools_simpleviewer']['dimensions'] = array(
    '#type' => 'fieldset',
    '#title' => t('Dimensions'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#description' => t('All dimensions should be given in pixels.'),
  );
  
  $form['swftools_simpleviewer']['dimensions']['width'] = array(
    '#type' => 'textfield',
    '#default_value' => $saved_settings['dimensions']['width'],
    '#size' => 5,
    '#maxlength' => 5,
    '#title' => t('Width of SimpleViewer'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['dimensions']['height'] = array(
    '#type' => 'textfield',
    '#default_value' => $saved_settings['dimensions']['height'],
    '#size' => 5,
    '#maxlength' => 5,
    '#title' => t('Height of SimpleViewer'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['dimensions']['maxImageWidth'] = array(
    '#type' => 'textfield',
    '#default_value' => $saved_settings['dimensions']['maxImageWidth'],
    '#size' => 5,
    '#maxlength' => 5,
    '#title' => t('Width of your largest image in pixels'),
    '#required' => TRUE,
    '#description' => t('Used to determine the best layout for your gallery.'),
  );
  
  $form['swftools_simpleviewer']['dimensions']['maxImageHeight'] = array(
    '#type' => 'textfield',
    '#default_value' => $saved_settings['dimensions']['maxImageHeight'],
    '#size' => 5,
    '#maxlength' => 5,
    '#title' => t('Height of your largest image in pixels'),
    '#required' => TRUE,
    '#description' => t('Used to determine the best layout for your gallery.'),
  );
  
  $form['swftools_simpleviewer']['dimensions']['frameWidth'] = array(
    '#type' => 'textfield',
    '#default_value' => $saved_settings['dimensions']['frameWidth'],
    '#size' => 5,
    '#maxlength' => 5,
    '#title' => t('Width of image frame in pixels'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['dimensions']['stagePadding'] = array(
    '#type' => 'textfield',
    '#default_value' => $saved_settings['dimensions']['stagePadding'],
    '#size' => 5,
    '#maxlength' => 5,
    '#title' => t('Stage padding'),
    '#description' => t('Distance between image and thumbnails and around gallery edge in pixels.'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['colors'] = array(
    '#type' => 'fieldset',
    '#title' => t('Colors'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#description' => t('All colors should be given as hexadecimal rgb-values like \'#FFFFFF\'.'),
  );

  $form['swftools_simpleviewer']['colors']['wmode'] = array(
    '#type' => 'checkbox',
    '#default_value' => $saved_settings['colors']['wmode'],
    '#title' => t('Transparency'),
    '#description' => t('Checking this box will make your background transparent. This setting overrides the background color setting.'),
  );
  
  $form['swftools_simpleviewer']['colors']['bgcolor'] = array(
    '#type' => $colorfield,
    '#default_value' => $saved_settings['colors']['bgcolor'],
    '#size' => 8,
    '#maxlength' => 7,
    '#title' => t('Background color'),
    '#description' => t('Background color of flash animation.'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['colors']['loader_color'] = array(
    '#type' => $colorfield,
    '#default_value' => $saved_settings['colors']['loader_color'],
    '#size' => 8,
    '#maxlength' => 7,
    '#title' => t('Flash loader color'),
    '#description' => t('Color of part of flash animation that says "loading xml data", while loading your gallery.'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['colors']['textColor'] = array(
    '#type' => $colorfield,
    '#default_value' => $saved_settings['colors']['textColor'],
    '#size' => 8,
    '#maxlength' => 7,
    '#title' => t('Text color'),
    '#description' => t('Color of title and caption text.'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['colors']['frameColor'] = array(
    '#type' => $colorfield,
    '#default_value' => $saved_settings['colors']['frameColor'],
    '#size' => 8,
    '#maxlength' => 7,
    '#title' => t('Frame color'),
    '#description' => t('Color of image frame, navigation buttons (on top and hover buttons) and thumbnail frame.'),
    '#required' => TRUE,
  );
  
  $form['swftools_simpleviewer']['navigation'] = array(
    '#type' => 'fieldset',
    '#title' => t('Navigation'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  
  // Create option settings
  $options = array();
  $options['int'] = drupal_map_assoc(array(0, 1, 2, 3, 4, 5));
  $options['position'] = drupal_map_assoc(array('top', 'bottom', 'left', 'right'));
  
  $form['swftools_simpleviewer']['navigation']['navPosition'] = array(
    '#type' => 'select',
    '#options' => $options['position'],
    '#default_value' => $saved_settings['navigation']['navPosition'],
    '#title' => t('Navigation position'),
    '#description' => t('Position of thumbnails relative to image.'),
  );
  
  $form['swftools_simpleviewer']['navigation']['thumbnailColumns'] = array(
    '#type' => 'select',
    '#options' => $options['int'],
    '#default_value' => $saved_settings['navigation']['thumbnailColumns'],
    '#title' => t('Thumbnail columns'),
    '#description' => t('Number of thumbnail columns. To disable thumbnails completely set this value to 0'),
  );

  $form['swftools_simpleviewer']['navigation']['thumbnailRows'] = array(
    '#type' => 'select',
    '#options' => $options['int'],
    '#default_value' => $saved_settings['navigation']['thumbnailRows'],
    '#title' => t('Thumbnail rows'),
    '#description' => t('Number of thumbnail rows. To disable thumbnails completely set this value to 0.'),
  );
  
  // Add custom form handler to flush cache upon submit
  $form['#submit'][] = 'swftools_admin_settings_submit';
  
  // Return finished form
  return system_settings_form($form);

}
